﻿//
// Copyright 2005 Elvis Mehmedovic.
// http://emehmedovic.com/
//

class xm.corpus.timeTrigger {

	private var __interval:Number;
	private var __iid:Number;
	private var __flist:Array;
	private var __time:Number = 0;
	private var __lastTriggerTime:Number = 0;
	private var __lastLaterTime:Number = 0;


	function timeTrigger(p_interval:Number) {
		__interval = p_interval;
		init();
	}

	function init(Void):Void {
		__flist = [];
	}

	private function __processTasks(Void):Void {

		__time += __interval;

		//trace("t: "+time);

		var n:String;
		var count:Number = 0;

		for (n in __flist) {

			var entry:Object = __flist[n];

			if (__time >= entry.t) {
				updateAfterEvent();

				entry.f.apply(entry.o, entry.a);
				delete __flist[n];
			}

		}

		for (n in __flist) {
			count++;
		}

		if (count < 1) {
			clearInterval(__iid);
			delete(__iid);
		}

	}

	private function __initializeNewTask(Void):Void {
		if (__iid == undefined) {
			__iid = setInterval(this, "__processTasks", __interval);
		}
	}

	function free(Void):Void {
		if (__iid) {
			clearInterval(__iid);
			delete(__iid);
		}
		__flist = [];
	}

	function get time():Number {
		return __time;
	}

	function triggerAbsAt(p_time:Number, p_obj:Object, p_meth:Function, p_args:Object):Void {
		__initializeNewTask();
		__lastTriggerTime = p_time;
		__flist.push({t:p_time, o:p_obj, f:p_meth, a:p_args});
	}

	function triggerAt(p_time:Number, p_obj:Object, p_meth:Function, p_args:Object):Void {
		__initializeNewTask();
		__lastTriggerTime = p_time+__time;
		__flist.push({t:p_time+__time, o:p_obj, f:p_meth, a:p_args});
	}

	function triggerFuncAt(p_time:Number, p_func:Function, p_args:Object):Void {
		triggerAt(p_time, undefined, p_func, p_args);
	}

}