﻿//
// Copyright 2005, 2006 Elvis Mehmedović.
// http://emehmedovic.com/
//

import xm.corpus.resizableComponent;
import xm.components.FLVDisplayComponent;

class xm.components.FLVControllerComponent extends resizableComponent {

	[IconFile("FLVControllerComponent.png")]
	
	var display:FLVDisplayComponent;
	
	[Inspectable(name="target")]
	var _targetInstanceName:MovieClip;
	
	function FLVControllerComponent() {
	}
	
	function addListeners(Void):Void {
		
		addEventListener("resize", this);
		display.addEventListenerL("resize", this, "resizeDisplay");
		
		display.addEventListener("resizeVideo", this);
		display.addEventListener("start", this);
		display.addEventListener("complete", this);
		display.addEventListener("progress", this);
		display.addEventListener("loaded", this);
		display.addEventListener("change", this);
		display.addEventListener("opening", this);
		display.addEventListener("seeking", this);
		display.addEventListener("closed", this);
		display.addEventListener("error", this);
		
		display.addEventListener("volume", this);
		display.addEventListener("zoom", this);

		display.addEventListener("playing", this);
		display.addEventListener("notPlaying", this);
		
		display.addEventListener("bufferEmpty", this);
		display.addEventListener("bufferFull", this);
		display.addEventListener("bufferFlush", this);

		// ToobPlayer 
		display.addEventListener("acquiringYouTubeUrl", this);
		display.addEventListener("acquiredYouTubeUrl", this);
		display.addEventListener("errorAcquiringYouTubeUrl", this);
		display.addEventListener("prePlay", this);
		display.addEventListener("preStop", this);

	}

	function init(Void):Void {

		super.init();
		nextFrame();
		
		display = evaluateTarget(_targetInstanceName);
		
		if (display.addEventListener) {
			addListeners();
		}
		else {
			if (!display.callWhenInitialized) {
				display.callWhenInitialized = new Array();
			}
			display.callWhenInitialized.push({f: addListeners, o: this});
		}

	}

}